var Server = IR.GetDevice("iRidium Server");
var ListBox = IR.GetItem("Page 1").GetItem("ListBox");
var EventNameField = IR.GetItem("Page 1").GetItem("EventName");
var Lamp = IR.GetItem("Page 1").GetItem("Lamp");
var Switch = IR.GetItem("Page 1").GetItem("Switch");
var EventStartField = IR.GetItem("Page 1").GetItem("EventStart");
var EventFinishField = IR.GetItem("Page 1").GetItem("EventFinish");
var EventStartField1 = IR.GetItem("Page 1").GetItem("EventStart 1");
var EventFinishField1 = IR.GetItem("Page 1").GetItem("EventFinish 1");
var UpdateButton = IR.GetItem("Page 1").GetItem("UpdateBtn");

var EventsObj;


var selectedItem = 0;

var events = [];

var EventProt = {}

/* var Event = function(inp) {
    this.Name;     // event name
    this.Start;   // event start date-time
    this.End;  // event finish date-time
    this.Enabled;
    this.Type;
    this.Day;
    this.End;
    this.WeekDays;
    this.RepeatEnd;
    this.MonthRepeatType;
    this.MonthDays;
    this.DayNumber;
    this.WeekDay;
    this.StartSunType;
    //TODO: Sun Offset
    for (var inpn in inp) {
        if (inp.hasOwnProperty(inpn)) 
            this[inpn] = inp[inpn];
    }
}
    
*/


var EventChanger = function(in_list) {

  var list = in_list;    //  link to GUI list with items and data
  var that = this;  
// read event data from virtual tag in JSON format and fill the list with items
  this.Read = function(in_ChannelName, in_Value) {         
    if (in_ChannelName == "EventData_from_server") {   
      //IR.Log("Now we parse " + in_Value);
      events = JSON.Parse(in_Value);
      for (i in events) {
        list.CreateItem(parseInt(i), 1, {Text: events[i].Name});
      }
      fill(selectedItem);
    }
  }
// write new date-times of event in virtual tag 
  this.Write = function(NEvent) {
    Server.Set("EventData_to_server", JSON.Stringify(NEvent));
  }
}

IR.AddListener(IR.EVENT_START,0,function() {
  EventsObj = new EventChanger(ListBox);
}); 

IR.AddListener(IR.EVENT_ITEM_SELECT, ListBox, function(item, subitem) {
  selectedItem = item;
  fill(selectedItem);
});
      
IR.AddListener(IR.EVENT_TAG_CHANGE, Server, function(name, value) {
  EventsObj.Read(name, value);
});
 
 
fill = function (in_item) {
  startTime = new Date(events[in_item].Start * 1000);
  finishTime = new Date(events[in_item].End * 1000);
  EventNameField.Text = events[in_item].Name;
  Lamp.Value = events[in_item].Enabled;
  Switch.Value = events[in_item].Enabled;
  EventStartField.Text = startTime;
  EventFinishField.Text = finishTime;
  EventStartField1.Text = startTime;
  EventFinishField1.Text = finishTime;
}

IR.AddListener(IR.EVENT_ITEM_PRESS, UpdateButton, function() {

  startTime = new Date(EventStartField1.Text);
  finishTime = new Date(EventFinishField1.Text);
  
  //var NEvent = new Event({Name:EventNameField.Text, Start: Math.floor(startTime.getTime()/1000), End: Math.floor(finishTime.getTime()/1000), Enabled: Switch.Value});
  var NEvent = {Name:EventNameField.Text, Start: Math.floor(startTime.getTime()/1000), End: Math.floor(finishTime.getTime()/1000), Enabled: Switch.Value};
  EventsObj.Write(NEvent); 
});
